//STB_MAX 0.0.1 2009:09:03 20:01:06$
//Copyright (c) 2009 solgracia
//Released under the GNU General Public License

// 
// Copyright (C) 2006, NinjaTrader LLC <www.ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    public class STB_MAX : Indicator
    {
        #region Variables
        // Wizard generated variables
            private int firstBarBack = 14; // Default setting for FirstBarBack
            private int lastBarBack = 0; // Default setting for LastBarBack
        // User defined variables (add any user defined variables below)
            private int _barsBack = 0;
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            CalculateOnBarClose	= false;
            Overlay				= true;
            PriceTypeSupported	= true;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
            double val = double.MinValue;
            _barsBack = 0;
            for (int barsBackIdx = Math.Min(CurrentBar, FirstBarBack - 1); barsBackIdx >= LastBarBack; barsBackIdx--)
            {
                if (Input[barsBackIdx] > val) _barsBack = barsBackIdx;
                val = Math.Max(val, Input[barsBackIdx]);
            }
            Value.Set(val);
        }

        #region Properties

        [Category("Parameters")]
        public int FirstBarBack
        {
            get { return firstBarBack; }
            set { firstBarBack = Math.Max(1, value); }
        }
        [Category("Parameters")]
        public int LastBarBack
        {
            get { return lastBarBack; }
            set { lastBarBack = Math.Max(0, value); }
        }
        public int BarsBack
        {
            get { return _barsBack; }
        }
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private STB_MAX[] cacheSTB_MAX = null;

        private static STB_MAX checkSTB_MAX = new STB_MAX();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public STB_MAX STB_MAX(int firstBarBack, int lastBarBack)
        {
            return STB_MAX(Input, firstBarBack, lastBarBack);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public STB_MAX STB_MAX(Data.IDataSeries input, int firstBarBack, int lastBarBack)
        {
            checkSTB_MAX.FirstBarBack = firstBarBack;
            firstBarBack = checkSTB_MAX.FirstBarBack;
            checkSTB_MAX.LastBarBack = lastBarBack;
            lastBarBack = checkSTB_MAX.LastBarBack;

            if (cacheSTB_MAX != null)
                for (int idx = 0; idx < cacheSTB_MAX.Length; idx++)
                    if (cacheSTB_MAX[idx].FirstBarBack == firstBarBack && cacheSTB_MAX[idx].LastBarBack == lastBarBack && cacheSTB_MAX[idx].EqualsInput(input))
                        return cacheSTB_MAX[idx];

            STB_MAX indicator = new STB_MAX();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.FirstBarBack = firstBarBack;
            indicator.LastBarBack = lastBarBack;
            indicator.SetUp();

            STB_MAX[] tmp = new STB_MAX[cacheSTB_MAX == null ? 1 : cacheSTB_MAX.Length + 1];
            if (cacheSTB_MAX != null)
                cacheSTB_MAX.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheSTB_MAX = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.STB_MAX STB_MAX(int firstBarBack, int lastBarBack)
        {
            return _indicator.STB_MAX(Input, firstBarBack, lastBarBack);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.STB_MAX STB_MAX(Data.IDataSeries input, int firstBarBack, int lastBarBack)
        {
            return _indicator.STB_MAX(input, firstBarBack, lastBarBack);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.STB_MAX STB_MAX(int firstBarBack, int lastBarBack)
        {
            return _indicator.STB_MAX(Input, firstBarBack, lastBarBack);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.STB_MAX STB_MAX(Data.IDataSeries input, int firstBarBack, int lastBarBack)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.STB_MAX(input, firstBarBack, lastBarBack);
        }

    }
}
#endregion
